In graph theory, graph coloring is a special case of graph labeling; it is an assignment of labels traditionally called "colors" to elements of a graph subject to certain constraints. In its simplest form, it is a way of coloring the vertices of a graph such that no two adjacent vertices are of the same color; this is called a vertex coloring. Similarly, an edge coloring assigns a color to each edge so that no two adjacent edges are of the same color, and a face coloring of a planar graph assigns a color to each face or region so that no two faces that share a boundary have the same color.
Vertex coloring is often used to introduce graph coloring problems, since other coloring problems can be transformed into a vertex coloring instance. For example, an edge coloring of a graph is just a vertex coloring of its line graph, and a face coloring of a plane graph is just a vertex coloring of its dual. However, non-vertex coloring problems are often stated and studied as-is. This is partly pedagogical, and partly because some problems are best studied in their non-vertex form, as in the case of edge coloring.
The convention of using colors originates from coloring the countries of a map, where each face is literally colored. This was generalized to coloring the faces of a graph embedded in the plane. By planar duality it became coloring the vertices, and in this form it generalizes to all graphs. In mathematical and computer representations, it is typical to use the first few positive or non-negative integers as the "colors". In general, one can use any finite set as the "color set". The nature of the coloring problem depends on the number of colors but not on what they are.
Graph coloring enjoys many practical applications as well as theoretical challenges. Beside the classical types of problems, different limitations can also be set on the graph, or on the way a color is assigned, or even on the color itself. It has even reached popularity with the general public in the form of the popular number puzzle Sudoku. Graph coloring is still a very active field of research.
Note: Many terms used in this article are defined in Glossary of graph theory.
The first results about graph coloring deal almost exclusively with planar graphs in the form of map coloring.While trying to color a map of the counties of England, Francis Guthrie postulated the four color conjecture, noting that four colors were sufficient to color the map so that no regions sharing a common border received the same color. Guthrie's brother passed on the question to his mathematics teacher Augustus De Morgan at University College, who mentioned it in a letter to William Hamilton in 1852. Arthur Cayley raised the problem at a meeting of the London Mathematical Society in 1879. The same year, Alfred Kempe published a paper that claimed to establish the result, and for a decade the four color problem was considered solved. For his accomplishment Kempe was elected a Fellow of the Royal Society and later President of the London Mathematical Society.[1]
In 1890, Percy John Heawood pointed out that Kempe's argument was wrong. However, in that paper he proved the five color theorem, saying that every planar map can be colored with no more than five colors, using ideas of Kempe. In the following century, a vast amount of work was done and theories were developed to reduce the number of colors to four, until the four color theorem was finally proved in 1976 by Kenneth Appel and Wolfgang Haken. The proof went back to the ideas of Heawood and Kempe and largely disregarded the intervening developments.The proof of the four color theorem is noteworthy, aside from its solution of a century-old problem, for being the first major computer-aided proof.
In 1912, George David Birkhoff introduced the chromatic polynomial to study the coloring problem, which was generalised to the Tutte polynomial by W. T. Tutte, both of which are important invariants in algebraic graph theory. Kempe had already drawn attention to the general, non-planar case in 1879, and many results on generalisations of planar graph coloring to surfaces of higher order followed in the early 20th century.
In 1960, Claude Berge formulated another conjecture about graph coloring, the strong perfect graph conjecture, originally motivated by an information-theoretic concept called the zero-error capacity of a graph introduced by Shannon. The conjecture remained unresolved for 40 years, until it was established as the celebrated strong perfect graph theorem by Chudnovsky, Robertson, Seymour, and Thomas in 2002.
Graph coloring has been studied as an algorithmic problem since the early 1970s: the chromatic number problem (see section
below) is one of Karp's 21 NP-complete problems from 1972, and at approximately the same time various exponential-time algorithms were developed based on backtracking and on the deletion-contraction recurrence of . One of the major applications of graph coloring, register allocation in compilers, was introduced in 1981.
When used without any qualification, a coloring of a graph almost always refers to a proper vertex coloring, namely a labeling of the graph's vertices with colors such that no two vertices sharing the same edge have the same color. Since a vertex with a loop (i.e. a connection directly back to itself) could never be properly colored, it is understood that graphs in this context are loopless.
The terminology of using colors for vertex labels goes back to map coloring. Labels like red and blue are only used when the number of colors is small, and normally it is understood that the labels are drawn from the integers
A coloring using at most colors is called a (proper) -coloring. The smallest number of colors needed to color a graph is called its chromatic number, and is often denoted . Sometimes is used, since is also used to denote the Euler characteristic of a graph. A graph that can be assigned a (proper) -coloring is -colorable, and it is -chromatic if its chromatic number is exactly . A subset of vertices assigned to the same color is called a color class, every such class forms an independent set. Thus, a -coloring is the same as a partition of the vertex set into independent sets, and the terms -partite and -colorable have the same meaning.
See main article: Chromatic polynomial.
The chromatic polynomial counts the number of ways a graph can be colored using some of a given number of colors. For example, using three colors, the graph in the adjacent image can be colored in 12 ways. With only two colors, it cannot be colored at all. With four colors, it can be colored in 24 + 4⋅12 = 72 ways: using all four colors, there are 4! = 24 valid colorings (every assignment of four colors to any 4-vertex graph is a proper coloring); and for every choice of three of the four colors, there are 12 valid 3-colorings. So, for the graph in the example, a table of the number of valid colorings would start like this:
Available colors | 1 | 2 | 3 | 4 | … | |
---|---|---|---|---|---|---|
Number of colorings | 0 | 0 | 12 | 72 | … |
The chromatic polynomial is a function that counts the number of -colorings of . As the name indicates, for a given the function is indeed a polynomial in . For the example graph,, and indeed .
The chromatic polynomial includes more information about the colorability of than does the chromatic number. Indeed, is the smallest positive integer that is not a zero of the chromatic polynomial
See main article: Edge coloring.
An edge coloring of a graph is a proper coloring of the edges, meaning an assignment of colors to edges so that no vertex is incident to two edges of the same color. An edge coloring with colors is called a -edge-coloring and is equivalent to the problem of partitioning the edge set into matchings. The smallest number of colors needed for an edge coloring of a graph is the chromatic index, or edge chromatic number, . A Tait coloring is a 3-edge coloring of a cubic graph. The four color theorem is equivalent to the assertion that every planar cubic bridgeless graph admits a Tait coloring.
See main article: Total coloring.
Total coloring is a type of coloring on the vertices and edges of a graph. When used without any qualification, a total coloring is always assumed to be proper in the sense that no adjacent vertices, no adjacent edges, and no edge and its end-vertices are assigned the same color. The total chromatic number of a graph is the fewest colors needed in any total coloring of .
For a graph with a strong embedding on a surface, the Face coloring is the dual of the vertex coloring problem.
For a graph G with a strong embedding on an orientable surface, William T. Tutte discovered that if the graph is k-face-colorable then G admits a nowhere-zero k-flow. The equivalence holds if the surface is sphere.
An unlabeled coloring of a graph is an orbit of a coloring under the action of the automorphism group of the graph. The colors remain labeled; it is the graph that is unlabeled.There is an analogue of the chromatic polynomial which counts the number of unlabeled colorings of a graph from a given finite color set.
If we interpret a coloring of a graph on vertices as a vector in, the action of an automorphism is a permutation of the coefficients in the coloring vector.
Assigning distinct colors to distinct vertices always yields a proper coloring, so
1\le\chi(G)\len.
Kn
\chi(Kn)=n
\chi(G)(\chi(G)-1)\le2m.
More generally a family
l{F}
\chi
c
G
l{F}
c(\omega(G))
c(\omega(G))=\omega(G)
The 2-colorable graphs are exactly the bipartite graphs, including trees and forests.By the four color theorem, every planar graph can be 4-colored.
A greedy coloring shows that every graph can be colored with one more color than the maximum vertex degree,
\chi(G)\le\Delta(G)+1.
Complete graphs have
\chi(G)=n
\Delta(G)=n-1
\chi(G)=3
\Delta(G)=2
\chi(G)\le\Delta(G)
Several lower bounds for the chromatic bounds have been discovered over the years:
If G contains a clique of size k, then at least k colors are needed to color that clique; in other words, the chromatic number is at least the clique number:
\chi(G)\ge\omega(G).
For perfect graphs this bound is tight. Finding cliques is known as the clique problem.
Hoffman's bound: Let
W
Wi,j=0
(i,j)
G
\chiW(G)=1-\tfrac{λmax(W)}{λmin(W)}
λmax(W),λmin(W)
W
W
\chiH(G)\leq\chi(G).
Let
W
Wi,j\le-\tfrac{1}{k-1}
(i,j)
G
\chiV(G)
W
\chiV(G)\leq\chi(G).
The Lovász number of a complementary graph is also a lower bound on the chromatic number:
\vartheta(\bar{G})\leq\chi(G).
The fractional chromatic number of a graph is a lower bound on the chromatic number as well:
\chif(G)\leq\chi(G).
These bounds are ordered as follows:
\chiH(G)\leq\chiV(G)\leq\vartheta(\bar{G})\leq\chif(G)\leq\chi(G).
Graphs with large cliques have a high chromatic number, but the opposite is not true. The Grötzsch graph is an example of a 4-chromatic graph without a triangle, and the example can be generalized to the Mycielskians.
Theorem : There exist triangle-free graphs with arbitrarily high chromatic number.
To prove this, both, Mycielski and Zykov, each gave a construction of an inductively defined family of triangle-free graphs but with arbitrarily large chromatic number. constructed axis aligned boxes in
R3
R3
R2
From Brooks's theorem, graphs with high chromatic number must have high maximum degree. But colorability is not an entirely local phenomenon: A graph with high girth looks locally like a tree, because all cycles are long, but its chromatic number need not be 2:
Theorem (Erdős): There exist graphs of arbitrarily high girth and chromatic number.
L(G)
\chi'(G)=\chi(L(G)).
There is a strong relationship between edge colorability and the graph's maximum degree
\Delta(G)
\chi'(G)\ge\Delta(G).
Moreover,
\chi'(G)=\Delta(G)
In general, the relationship is even stronger than what Brooks's theorem gives for vertex coloring:
Vizing's Theorem: A graph of maximal degree
\Delta
\Delta
\Delta+1
A graph has a k-coloring if and only if it has an acyclic orientation for which the longest path has length at most k; this is the Gallai–Hasse–Roy–Vitaver theorem .
For planar graphs, vertex colorings are essentially dual to nowhere-zero flows.
About infinite graphs, much less is known.The following are two of the few results about infinite graph coloring:
As stated above,
\omega(G)\le\chi(G)\le\Delta(G)+1.
\chi(G)\le\left\lceil
\omega(G)+\Delta(G)+1 | |
2 |
\right\rceil.
The chromatic number of the plane, where two points are adjacent if they have unit distance, is unknown, although it is one of 5, 6, or 7. Other open problems concerning the chromatic number of graphs include the Hadwiger conjecture stating that every graph with chromatic number k has a complete graph on k vertices as a minor, the Erdős–Faber–Lovász conjecture bounding the chromatic number of unions of complete graphs that have at most one vertex in common to each pair, and the Albertson conjecture that among k-chromatic graphs the complete graphs are the ones with smallest crossing number.
When Birkhoff and Lewis introduced the chromatic polynomial in their attack on the four-color theorem, they conjectured that for planar graphs G, the polynomial
P(G,t)
[4,infty)
[5,infty)
P(G,4) ≠ 0
Above: | Graph coloring |
Labelstyle: | font-weight:normal |
Headerstyle: | background: #DD9 |
Abovestyle: | background: #DD9 |
Header1: | Decision |
Label2: | Name |
Data2: | Graph coloring, vertex coloring, k-coloring |
Label3: | Input |
Data3: | Graph G with n vertices. Integer k |
Label4: | Output |
Data4: | Does G admit a proper vertex coloring with k colors? |
Label5: | Running time |
Data5: | O(2 nn) |
Label6: | Complexity |
Data6: | NP-complete |
Label7: | Reduction from |
Data7: | 3-Satisfiability |
Label8: | Garey–Johnson |
Data8: | GT4 |
Header9: | Optimisation |
Label10: | Name |
Data10: | Chromatic number |
Label11: | Input |
Data11: | Graph G with n vertices. |
Label12: | Output |
Data12: | χ(G) |
Label13: | Complexity |
Data13: | NP-hard |
Label14: | Approximability |
Data14: | O(n (log n)-3(log log n)2) |
Label15: | Inapproximability |
Data15: | O(n1-ε) unless P = NP |
Header16: | Counting problem |
Label17: | Name |
Data17: | Chromatic polynomial |
Label19: | Input |
Data19: | Graph G with n vertices. Integer k |
Label20: | Output |
Data20: | The number P (G,k) of proper k-colorings of G |
Label21: | Running time |
Data21: | O(2 nn) |
Label22: | Complexity |
Data22: |
|
Label23: | Approximability |
Data23: | FPRAS for restricted cases |
Label24: | Inapproximability |
Data24: | No PTAS unless P = NP |
Determining if a graph can be colored with 2 colors is equivalent to determining whether or not the graph is bipartite, and thus computable in linear time using breadth-first search or depth-first search. More generally, the chromatic number and a corresponding coloring of perfect graphs can be computed in polynomial time using semidefinite programming. Closed formulas for chromatic polynomials are known for many classes of graphs, such as forests, chordal graphs, cycles, wheels, and ladders, so these can be evaluated in polynomial time.
If the graph is planar and has low branch-width (or is nonplanar but with a known branch decomposition), then it can be solved in polynomial time using dynamic programming. In general, the time required is polynomial in the graph size, but exponential in the branch-width.
Brute-force search for a k-coloring considers each of the
kn
k=1,\ldots,n-1
Using dynamic programming and a bound on the number of maximal independent sets, k-colorability can be decided in time and space
O(2.4423n)
O(2nn)
O(1.3289n)
O(1.7272n)
G/uv
The chromatic number satisfies the recurrence relation:
\chi(G)=min\{\chi(G+uv),\chi(G/uv)\}
G+uv
The chromatic polynomial satisfies the following recurrence relation
P(G-uv,k)=P(G/uv,k)+P(G,k)
G-uv
P(G-uv,k)
These expressions give rise to a recursive procedure called the deletion–contraction algorithm, which forms the basis of many algorithms for graph coloring. The running time satisfies the same recurrence relation as the Fibonacci numbers, so in the worst case the algorithm runs in time within a polynomial factor of
\left(\tfrac{1+\sqrt{5}}2\right)n+m=O(1.6180n+m)
t(G)
See main article: Greedy coloring.
The greedy algorithm considers the vertices in a specific order
v1
vn
vi
vi
v1
vi-1
\chi(G)
n/2
For chordal graphs, and for special cases of chordal graphs such as interval graphs and indifference graphs, the greedy coloring algorithm can be used to find optimal colorings in polynomial time, by choosing the vertex ordering to be the reverse of a perfect elimination ordering for the graph. The perfectly orderable graphs generalize this property, but it is NP-hard to find a perfect ordering of these graphs.
If the vertices are ordered according to their degrees, the resulting greedy coloring uses at most
maximin \{d(xi)+1,i\}
The maximum (worst) number of colors that can be obtained by the greedy algorithm, by using a vertex ordering chosen to maximize this number, is called the Grundy number of a graph.
Two well-known polynomial-time heuristics for graph colouring are the DSatur and recursive largest first (RLF) algorithms.
Similarly to the greedy colouring algorithm, DSatur colours the vertices of a graph one after another, expending a previously unused colour when needed. Once a new vertex has been coloured, the algorithm determines which of the remaining uncoloured vertices has the highest number of different colours in its neighbourhood and colours this vertex next. This is defined as the degree of saturation of a given vertex.
The recursive largest first algorithm operates in a different fashion by constructing each color class one at a time. It does this by identifying a maximal independent set of vertices in the graph using specialised heuristic rules. It then assigns these vertices to the same color and removes them from the graph. These actions are repeated on the remaining subgraph until no vertices remain.
The worst-case complexity of DSatur is
O(n2)
n
O((n+m)logn)
m
O(mn)
DSatur and RLF are exact for bipartite, cycle, and wheel graphs.
In the field of distributed algorithms, graph coloring is closely related to the problem of symmetry breaking. The current state-of-the-art randomized algorithms are faster for sufficiently large maximum degree Δ than deterministic algorithms. The fastest randomized algorithms employ the multi-trials technique by Schneider and Wattenhofer.
In a symmetric graph, a deterministic distributed algorithm cannot find a proper vertex coloring. Some auxiliary information is needed in order to break symmetry. A standard assumption is that initially each node has a unique identifier, for example, from the set . Put otherwise, we assume that we are given an n-coloring. The challenge is to reduce the number of colors from n to, e.g., Δ + 1. The more colors are employed, e.g. O(Δ) instead of Δ + 1, the fewer communication rounds are required.
A straightforward distributed version of the greedy algorithm for (Δ + 1)-coloring requires Θ(n) communication rounds in the worst case − information may need to be propagated from one side of the network to another side.
The simplest interesting case is an n-cycle. Richard Cole and Uzi Vishkin[2] show that there is a distributed algorithm that reduces the number of colors from n to O(log n) in one synchronous communication step. By iterating the same procedure, it is possible to obtain a 3-coloring of an n-cycle in O( n) communication steps (assuming that we have unique node identifiers).
The function, iterated logarithm, is an extremely slowly growing function, "almost constant". Hence the result by Cole and Vishkin raised the question of whether there is a constant-time distributed algorithm for 3-coloring an n-cycle. showed that this is not possible: any deterministic distributed algorithm requires Ω( n) communication steps to reduce an n-coloring to a 3-coloring in an n-cycle.
The technique by Cole and Vishkin can be applied in arbitrary bounded-degree graphs as well; the running time is poly(Δ) + O( n). The technique was extended to unit disk graphs by Schneider and Wattenhofer. The fastest deterministic algorithms for (Δ + 1)-coloring for small Δ are due to Leonid Barenboim, Michael Elkin and Fabian Kuhn.[3] The algorithm by Barenboim et al. runs in time O(Δ) + (n)/2, which is optimal in terms of n since the constant factor 1/2 cannot be improved due to Linial's lower bound. use network decompositions to compute a Δ+1 coloring in time
2 O\left(\sqrt{log\right)}
The problem of edge coloring has also been studied in the distributed model. achieve a (2Δ - 1)-coloring in O(Δ + n) time in this model. The lower bound for distributed vertex coloring due to applies to the distributed edge coloring problem as well.
Decentralized algorithms are ones where no message passing is allowed (in contrast to distributed algorithms where local message passing takes places), and efficient decentralized algorithms exist that will color a graph if a proper coloring exists. These assume that a vertex is able to sense whether any of its neighbors are using the same color as the vertex i.e., whether a local conflict exists. This is a mild assumption in many applications e.g. in wireless channel allocation it is usually reasonable to assume that a station will be able to detect whether other interfering transmitters are using the same channel (e.g. by measuring the SINR). This sensing information is sufficient to allow algorithms based on learning automata to find a proper graph coloring with probability one.[4]
Graph coloring is computationally hard. It is NP-complete to decide if a given graph admits a k-coloring for a given k except for the cases k ∈ . In particular, it is NP-hard to compute the chromatic number.[5] The 3-coloring problem remains NP-complete even on 4-regular planar graphs. On graphs with maximal degree 3 or less, however, Brooks' theorem implies that the 3-coloring problem can be solved in linear time. Further, for every k > 3, a k-coloring of a planar graph exists by the four color theorem, and it is possible to find such a coloring in polynomial time. However, finding the lexicographically smallest 4-coloring of a planar graph is NP-complete.
The best known approximation algorithm computes a coloring of size at most within a factor O(n(log log n)2(log n)−3) of the chromatic number. For all ε > 0, approximating the chromatic number within n1-ε is NP-hard.
It is also NP-hard to color a 3-colorable graph with 5 colors, 4-colorable graph with 7 colours, and a k-colorable graph with
style\binomk{\lfloork/2\rfloor}-1
Computing the coefficients of the chromatic polynomial is
. In fact, even computing the value of
\chi(G,k)
For edge coloring, the proof of Vizing's result gives an algorithm that uses at most Δ+1 colors. However, deciding between the two candidate values for the edge chromatic number is NP-complete. In terms of approximation algorithms, Vizing's algorithm shows that the edge chromatic number can be approximated to within 4/3,and the hardness result shows that no (4/3 - ε )-algorithm exists for any ε > 0 unless P = NP. These are among the oldest results in the literature of approximation algorithms, even though neither paper makes explicit use of that notion.
Vertex coloring models to a number of scheduling problems. In the cleanest form, a given set of jobs need to be assigned to time slots, each job requires one such slot. Jobs can be scheduled in any order, but pairs of jobs may be in conflict in the sense that they may not be assigned to the same time slot, for example because they both rely on a shared resource. The corresponding graph contains a vertex for every job and an edge for every conflicting pair of jobs. The chromatic number of the graph is exactly the minimum makespan, the optimal time to finish all jobs without conflicts.
Details of the scheduling problem define the structure of the graph. For example, when assigning aircraft to flights, the resulting conflict graph is an interval graph, so the coloring problem can be solved efficiently. In bandwidth allocation to radio stations, the resulting conflict graph is a unit disk graph, so the coloring problem is 3-approximable.
See main article: Register allocation.
A compiler is a computer program that translates one computer language into another. To improve the execution time of the resulting code, one of the techniques of compiler optimization is register allocation, where the most frequently used values of the compiled program are kept in the fast processor registers. Ideally, values are assigned to registers so that they can all reside in the registers when they are used.
The textbook approach to this problem is to model it as a graph coloring problem. The compiler constructs an interference graph, where vertices are variables and an edge connects two vertices if they are needed at the same time. If the graph can be colored with k colors then any set of variables needed at the same time can be stored in at most k registers.
The problem of coloring a graph arises in many practical areas such as sports scheduling, designing seating plans, exam timetabling, the scheduling of taxis, and solving Sudoku puzzles.
See main article: Ramsey theory.
An important class of improper coloring problems is studied in Ramsey theory, where the graph's edges are assigned to colors, and there is no restriction on the colors of incident edges. A simple example is the theorem on friends and strangers, which states that in any coloring of the edges of
K6